Bug 226997

Summary: sysutils/dupd: fails to link with lld as the system linker
Product: Ports & Packages Reporter: Ed Maste <emaste>
Component: Individual Port(s)Assignee: freebsd-ports-bugs mailing list <ports-bugs>
Status: Closed FIXED    
Severity: Affects Only Me CC: tom
Priority: --- Flags: bugzilla: maintainer-feedback? (tom)
Version: Latest   
Hardware: Any   
OS: Any   
Bug Depends on:    
Bug Blocks: 214864    

Description Ed Maste freebsd_committer 2018-03-27 16:37:52 UTC
I'm working on switching to LLVM's lld linker as the FreeBSD system linker (/usr/bin/ld)[1], and the port in this PR is reported as a new failure in the exp-run, PR 214864.

An excerpt from the build log[2]:
---
ld -r -b binary -o /wrkdirs/usr/ports/sysutils/dupd/work/dupd-1.4/build/usage.o man/dupd
ld: error: target emulation unknown: -m or at least one .o file required---

Known issues in this port or in lld that affect this port:

(4) lld does not have a built-in default output target. For the most common use of the linker (linking individual .o objects into an executable or shared object) lld infers the target from the first object file. However, when the linker is used to convert an arbitrary binary file into an ELF object (via -r -b binary) lld must have the output target specified explicitly with -m.

FreeBSD 11 and later have lld available as /usr/bin/ld.lld, so one simple option for testing is to just symlink /usr/bin/ld to ld.lld (and restore it to ld.bfd).

A port Makefile knob, LLD_UNSAFE=yes, exists to indicate that a port does not work with lld, and requires either /usr/bin/ld.bfd or binutils from ports. This should work for the common case of ports written in C using GNU autoconf; it may have no effect on other ports.

[1] https://lists.freebsd.org/pipermail/freebsd-current/2018-March/068985.html
[2] http://package18.nyi.freebsd.org/data/headamd64PR214864-default/2018-03-21_17h43m11s/logs/errors/dupd-1.4.log
Comment 1 Ed Maste freebsd_committer 2018-03-27 20:39:22 UTC
Via tobik@ in ports r465725, BINARY_ALIAS=ld=ld.bfd may be an effective workaround if LLD_UNSAFE does not work.
Comment 2 commit-hook freebsd_committer 2018-03-28 13:46:14 UTC
A commit references this bug:

Author: krion
Date: Wed Mar 28 13:45:52 UTC 2018
New revision: 465810
URL: https://svnweb.freebsd.org/changeset/ports/465810

Log:
  Switch to ld.bfd by default as ld.ldd doesn't have built-in default
  output target. Pet portlint(1).

  PR:		226997
  Submitted by:	emaste
  Approved by:	portmgr (LLD_UNSAFE blanket)

Changes:
  head/sysutils/dupd/Makefile